<html layout:decorate="~{layout/main}"
      th:with="pageTitle=#{pageTitle.listOccurrence}"
      xmlns:th="http://www.w3.org/1999/html">

<th:block layout:fragment="js-view">
    <script src="/js/default/pagination.js"></script>
</th:block>

<th:block layout:fragment="css-view">
    <link href="/css/occurrence/list.css" rel="stylesheet" type="text/css"/>
</th:block>

<div layout:fragment="content">
    <div class="container">
        <div class="card">

            <div class="card-header">
                <div class="float-right">
                    <a id="create-occurrence-button" class="btn btn-secondary" th:href="@{/occurrence/create}"
                       th:text="#{occurrence.create}"></a>
                </div>
            </div>

            <div class="card-body">
                <form method="get" th:object="${searchForm}">
                    <div class="row ml-auto">
                        <input th:field="*{page}" th:value="1" type="hidden">

                        <div class="col-md-4">
                            <div class="form-group">
                                <label for="searchTerm" th:text="#{occurrenceSearch.searchTerm}"></label>
                                <input class="form-control" id="searchTerm" th:field="*{searchTerm}"
                                       th:placeholder="#{occurrence.search.placeholder}"
                                       type="text">
                            </div>
                        </div>

                        <th:block>
                            <div class="col-md-4">
                                <div class="form-group">
                                    <label for="occurrenceStatus" th:text="#{occurrenceSearch.status}"></label>
                                    <select class="select2" id="occurrenceStatus"
                                            data-allow-clear="true"
                                            th:attr="data-placeholder=#{occurrenceStatus.all}"
                                            th:field="*{occurrenceStatusEnum}">
                                        <option value=""></option>
                                            <option th:each="status : ${T(felipe.emerim.crimespot.enums.OccurrenceStatusEnum).values()}"
                                                    th:text="#{${status.description}}" th:value="${status}"></option>
                                    </select>
                                </div>
                            </div>

                            <div class="col-md-4">
                                <div class="form-group">
                                    <label for="occurrenceSort" th:text="#{occurrenceSearch.order}"></label>
                                    <select class="select2" id="occurrenceSort"
                                            th:attr="data-placeholder=#{occurrenceSort.placeholder}"
                                            th:field="*{occurrenceSortEnum}">
                                        <option value=""></option>
                                        <th:block sec:authorize="hasRole('ROLE_MODERATOR')">
                                            <option th:each="sort : ${T(felipe.emerim.crimespot.enums.OccurrenceSortEnum).values()}"
                                                    th:text="#{${sort.description}}" th:value="${sort}"></option>
                                        </th:block>

                                        <!-- Hide MOST_REPORTED filter from non moderator users -->
                                        <th:block sec:authorize="not hasRole('ROLE_MODERATOR')"
                                                  th:with="excludes=${ {T(felipe.emerim.crimespot.enums.OccurrenceSortEnum).MOST_REPORTED} }">
                                            <option th:each="sort : ${T(felipe.emerim.crimespot.enums.OccurrenceSortEnum).values()}"
                                                    th:text="#{${sort.description}}" th:value="${sort}"
                                                    th:if="${not #lists.contains(excludes, sort)}"></option>
                                        </th:block>
                                    </select>
                                </div>
                            </div>

                            <div class="col-md-6">
                                <div class="form-group">
                                    <label for="occurrenceTypes" th:text="#{occurrenceSearch.type}"></label>
                                    <select class="select2-multiple" id="occurrenceTypes" multiple
                                            th:attr="data-placeholder=#{occurrenceType.all}"
                                            th:field="*{occurrenceTypeEnums}">
                                            <option th:each="type : ${T(felipe.emerim.crimespot.enums.OccurrenceTypeEnum).values()}"
                                                    th:text="#{${type.description}}" th:value="${type}"></option>
                                    </select>
                                </div>
                            </div>

                            <div class="col-md-3 mt-auto" sec:authorize="hasAuthority('ROLE_MODERATOR')">
                                <div class="form-group">
                                    <div class="form-check form-check-inline">
                                        <input class="form-check-input" id="only-related-to-me"
                                               th:field="*{onlyRelatedToMe}"
                                               type="checkbox">
                                        <label class="form-check-label" for="only-related-to-me"
                                               th:text="#{occurrenceFilter.onlyRelatedToMe}"></label>
                                    </div>
                                </div>
                            </div>
                        </th:block>

                        <div class="col-md-2 ml-md-auto mt-md-auto mb-md-3">
                            <div class="form-group">
                                <button class="btn btn-secondary float-right" id="search-button"
                                        th:text="#{occurrence.list.search}"
                                        type="submit">
                                    Pesquisar
                                </button>
                            </div>
                        </div>
                    </div>
                </form>

                <hr>

                <div id="no-results-container"
                     class="m-auto" th:if="${occurrences.data.size() == 0}" th:text="#{occurrence.list.noResults}">
                    Nenhum resultado encontrado
                </div>

                <th:block th:each="occurrence : ${occurrences.data}">
                    <div class="callout callout-secondary">
                        <div class="row">
                            <div class="col-md-12">
                                <span class="h5" th:text="${occurrence.title}"></span>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-md-12" th:if="${#strings.length(occurrence.description)>99}">
                                <span class="small" th:text="${#strings.substring(occurrence.description,0,99)}">
                                </span>
                                <span>...</span>
                            </div>

                            <div class="col-md-12" th:if="${#strings.length(occurrence.description)<=99}">
                                <span class="small" th:text="${occurrence.description}"></span>
                            </div>
                        </div>

                        <hr/>

                        <div class="row">
                            <div class="col-md-6">
                                <span th:text="|#{occurrence.label.user}: ${occurrence.user.username}|"></span>
                            </div>
                            <div class="col-md-6">
                                <span th:text="|#{occurrence.label.occurrenceDate}: ${#temporals.format(occurrence.occurrenceDate, 'dd/MMM/yyyy')}|"></span>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-md-6">
                                <span th:text="|#{occurrence.label.city}: ${occurrence.address.city}|"></span>
                            </div>
                            <div class="col-md-6">
                                <span th:text="|#{occurrence.label.street}: ${occurrence.address.street}|"></span>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-md-6">
                                <span th:text="|#{occurrence.label.occurrenceType}: #{${occurrence.occurrenceType.description.description}}|"></span>
                            </div>
                            <div class="col-md-6">
                                <span th:text="|#{occurrence.label.occurrenceStatus}: #{${occurrence.occurrenceStatus.description.description}}|"></span>
                            </div>
                        </div>

                        <div class="row">

                            <div class="col-md-6">
                                <span th:text="#{occurrence.label.createdAt}"></span> <span class="local-date-time" th:text="${occurrence.createdAt}"></span>
                            </div>

                            <div class="col-md-6">
                                <span th:text="#{occurrence.label.updatedAt}"></span> <span class="local-date-time" th:text="${occurrence.updatedAt}"></span>
                            </div>

                        </div>

                        <div class="row">
                            <div class="col-md-6" sec:authorize="hasRole('ROLE_MODERATOR')">
                                <span th:text="|#{occurrence.label.reportsCount}: ${occurrence.reportsCount}|"></span>
                            </div>
                            <div class="col-md-6" th:if="${occurrence.moderator != null}">
                                <span th:text="|#{occurrence.label.moderator}: ${occurrence.moderator.username}|"></span>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-md-3 ml-auto">
                                <a class="btn btn-secondary btn-sm float-right btn-see-details"
                                   th:href="@{|/occurrence/view/${occurrence.id}|}"
                                   th:text="#{occurrence.list.seeDetails}"
                                   th:unless="${occurrence.isInReviewByUser(user)}">

                                </a>

                                <a class="btn btn-secondary btn-sm float-right btn-continue-review"
                                   th:href="@{|/occurrence/view/${occurrence.id}|}"
                                   th:if="${occurrence.isInReviewByUser(user)}"
                                   th:text="#{occurrence.continueReview}">

                                </a>
                            </div>
                        </div>

                    </div>
                </th:block>


            </div>

            <div class="card-footer">
                <th:block th:insert="layout/fragments/pagination ::pagination(${occurrences})"></th:block>
            </div>

        </div>
    </div>
</div>
</html>